unable to trap in doze

01/20/2010 04:16 AM - rogerdpack (Roger Pack)

Status: Closed   

Priority: Normal   

Assignee: ko1 (Koichi Sasada)   

Target version: 2.0.0   

ruby -v: - Backport:  

Description

=begin

this snippet:

trap("ILL") { puts 'got one' }

Thread.new { sleep 0.1;Process.kill "ILL", Process.pid}

sleep

appears to work like a champ in 1.8, and fail for 1.9.x

=end

Associated revisions

Revision 89e2951b - 07/12/2011 04:55 AM - kosaki (Motohiro KOSAKI)

signal.c (sig_trap): don't permit to change a signal handler which

the interpreter reserved.

signal.c (reserved_signal_p): ditto.

[Bug #2616] [ruby-core:27625]

test/ruby/test_signal.rb (TestSignal#test_reserved_signal):

added a test for reserved signal.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@32523 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 01/25/2010 09:12 PM - usa (Usaku NAKAMURA)

- Status changed from Open to Assigned

- Assignee set to usa (Usaku NAKAMURA)

=begin

signals to myself which mapped to SEH seems to be ignored...

Of course, this is a bug.

=end

#2 - 03/13/2010 10:37 PM - wanabe (_ wanabe)

- File th_sigill.patch added

=begin

I guess SIGILL is reset in child thread.

I wrote a patch, but this validity is very doubtful.

I'd appreciate anyone to correct the patch.

=end

#3 - 03/14/2010 12:51 AM - usa (Usaku NAKAMURA)

=begin

Hello,

In message "[ruby-core:28641] [Bug #2616] unable to trap in doze"
on Mar.13,2010 22:37:33, redmine@ruby-lang.org wrote:

I guess SIGILL is reset in child thread.

I wrote a patch, but this validity is very doubtful.

I'd appreciate anyone to correct the patch.

 With this patch, re-defining the signal handler on another thread

(such as main thread), each threads has another handler, doesn't

it?

I think that all child threads should define handlers for SEH'ed

signals to redirect the signals to main thread.

Regards,

U.Nakamura usa@garbagecollect.jp

=end

#4 - 06/03/2010 10:27 AM - usa (Usaku NAKAMURA)

- Priority changed from Normal to 5

- Target version set to 2.0.0

=begin

=end

#5 - 06/03/2010 10:27 AM - usa (Usaku NAKAMURA)

- Target version changed from 2.0.0 to 1.9.2

=begin

=end

#6 - 06/03/2010 10:34 AM - usa (Usaku NAKAMURA)

- Due date set to 06/30/2010

=begin

wanabe-san, do you still track this problem?

=end

#7 - 06/03/2010 11:16 PM - wanabe (_ wanabe)

=begin

wanabe-san, do you still track this problem?

 No. I wanted to write a patch, but I couldn't.

This problem is too difficult for me. Sorry.

=end

#8 - 06/07/2010 02:24 PM - usa (Usaku NAKAMURA)

- Assignee changed from usa (Usaku NAKAMURA) to ko1 (Koichi Sasada)

=begin

=end

#9 - 06/18/2010 02:43 AM - mame (Yusuke Endoh)

=begin

Hi, ko1

This ticket is somehow assigned to you.

Do you have any idea to fix this issue?
If not, I, as an assistant release manager, determine this as

WONTFIX for 1.9.2.

--

Yusuke Endoh mame@tsg.ne.jp

=end

#10 - 06/23/2010 10:04 PM - mame (Yusuke Endoh)

- Target version changed from 1.9.2 to 2.0.0

=begin

No response.  This won't be fixed in 1.9.2.

--

Yusuke Endoh mame@tsg.ne.jp

=end

#11 - 06/26/2011 11:30 PM - nahi (Hiroshi Nakamura)

- Target version changed from 2.0.0 to 1.9.3

#12 - 07/11/2011 03:34 PM - kosaki (Motohiro KOSAKI)

- Category set to core

- Priority changed from 5 to 3

- Target version changed from 1.9.3 to 2.0.0

This issue need to be rewritten signal related code widely and SIGILL isn't so much important on practical application.

Therefore I'll change target version.

#13 - 07/11/2011 03:40 PM - kosaki (Motohiro KOSAKI)

For clarification, now SIGFPE, SIGILL and SIGSEGV can't be trapped from ruby script if you have multi threads and use windows.

but I don't think it's big matter.

#14 - 07/12/2011 01:55 PM - kosaki (Motohiro KOSAKI)

- Status changed from Assigned to Closed

- % Done changed from 0 to 100

This issue was solved with changeset r32523.

Roger, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.

May Ruby be with you.

signal.c (sig_trap): don't permit to change a signal handler which

the interpreter reserved.

signal.c (reserved_signal_p): ditto.

[Bug #2616] [ruby-core:27625]

test/ruby/test_signal.rb (TestSignal#test_reserved_signal):

added a test for reserved signal.

#15 - 07/13/2011 11:23 AM - Anonymous

For clarification, now SIGFPE, SIGILL and SIGSEGV can't be trapped from ruby script if you have multi threads and use windows.

but I don't think it's big matter.

 Agreed--nobody seems to have noticed it but myself until now...

#16 - 07/13/2011 07:29 PM - kosaki (Motohiro KOSAKI)

- ruby -v changed from ruby 1.9.2dev (2010-01-06 trunk 26246) [i386-mingw32] to -
For clarification, now SIGFPE, SIGILL and SIGSEGV can't be trapped from ruby script if you have multi threads and use windows.

but I don't think it's big matter.

 Agreed--nobody seems to have noticed it but myself until now...

 The point is, this issue is not mere bug. It's YARV core design issue.

As you know, ruby 1.9 can have multi threads. But many script don't

have proper multi thread safe trap code. Thus we decided always execute

trap hander by main thread. But, synchronous signal (e.g. SIGSEGV, SIGILL)

can't be delivered to other threads. It's synchronous.

Therefore, I'm planning to don't permit to use trap of synchrounous signal since

1.9.4 or later. Of course, every comments are welcome.

Thanks.

Files

th_sigill.patch 1005 Bytes 03/13/2010 wanabe (_ wanabe)
